using System;
using System.Collections.Generic;

namespace Schedulable.Show
{
    public class Show
    {
        public PreshowTaskList PreShow { get; set; }
        public TaskList PostShow { get; set; }

        #region components
        public class TaskList
        {
            public IEnumerable<Checklistable> Manual { get; set; }
            public IEnumerable<string> Commands { get; set; }
        }
        public class PreshowTaskList : TaskList
        {
            public IEnumerable<string> AgentsNeeded { get; set; }
            public IEnumerable<string> Checks { get; set; }
        }
        public class Checklistable
        {
            //for humans
            public string Label { get; set; }
            public IEnumerable<Checklistable> Items { get; set; } //if no items, just throw up a checkbox
        }
        #endregion
    }

    public class TwitchStream : Show
    {
        public string TwitchTitle { get; set; }
        public string TwitchCategory { get; set; }
    }
    public class YoutubeRelease : Show { }
}